//
// MG-002: CATATONIC
// This is coded fast, loose, and unsafe as hell.
// For the love of god, don't code a real game like this, okay?
//
#define  PULL_EXTERNS
#include "Project.h"







// Misc stuff
//
void draw_actor(int slot);
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint);
void draw_signal();
void render_frame(int mode);    // Standard rendering
void render_post_frame();       // Standard post-processing pass
void merge_actors();
void prep_for_sort();
void cleanup();







void load_textures()
{
 tex_title        = LoadTexture("gfx/tex_title.png");
 tex_title_bg     = LoadTexture("gfx/tex_title_bg.png");
 tex_summary_bg   = LoadTexture("gfx/tex_summary_bg.png");
 tex_emoji_1      = LoadTexture("gfx/tex_emoji_1.png");
 tex_emoji_2      = LoadTexture("gfx/tex_emoji_2.png");
 tex_emoji_3      = LoadTexture("gfx/tex_emoji_3.png");
 tex_emoji_4      = LoadTexture("gfx/tex_emoji_4.png");

 tex_32x          = LoadTexture("gfx/tex_32x.png");
 //tex_64x          = LoadTexture("gfx/tex_64x.png");
 box_tex          = LoadTexture("gfx/box_tex.png");

 tex_clouds       = LoadTexture("gfx/tex_clouds.png");
 tex_container    = LoadTexture("gfx/tex_container.png");
 tex_moai         = LoadTexture("gfx/tex_moai.png");
 tex_aura         = LoadTexture("gfx/tex_aura.png");
 tex_stars        = LoadTexture("gfx/tex_stars.png");
 tex_stripes      = LoadTexture("gfx/tex_stripes.png");

 /// Project specific
 ///
 SetTextureWrap(tex_clouds, TEXTURE_WRAP_REPEAT);
 SetTextureWrap(tex_stripes, TEXTURE_WRAP_REPEAT);

 return;
}



void load_fonts()
{
 font1 = LoadFont("gfx/noop_01.png");
 font3 = LoadFont("gfx/3x_square.png");
 font4 = LoadFont("gfx/7x_buck.png");
 font5 = LoadFont("gfx/c_font.png");

 hi_score_font = font1;
 controls_font = font3;
 summary_font  = font1;
 title_font    = font1;
 hud_font      = font1;

 return;
}



void load_shaders()
{
 // Wave Shader crap
 //


 wave       = LoadShader(0, TextFormat("shaders/wave_%i.fs", GLSL_VERSION));
 secondsLoc = GetShaderLocation(wave, "secondes");
 freqXLoc   = GetShaderLocation(wave, "freqX");
 freqYLoc   = GetShaderLocation(wave, "freqY");
 ampXLoc    = GetShaderLocation(wave, "ampX");
 ampYLoc    = GetShaderLocation(wave, "ampY");
 speedXLoc  = GetShaderLocation(wave, "speedX");
 speedYLoc  = GetShaderLocation(wave, "speedY");

 SetShaderValue(wave,   GetShaderLocation(wave, "size"), &flags.screenSize, SHADER_UNIFORM_VEC2);


 // Mosaic crap
 //
 mosaic   = LoadShader(0, TextFormat("shaders/mosaic_%i.fs", GLSL_VERSION));
 mos_mLoc = GetShaderLocation(mosaic, "mosaic_size");
 mos_aLoc = GetShaderLocation(mosaic, "aspect");

 SetShaderValue(mosaic, mos_mLoc, &flags.mosaic, SHADER_UNIFORM_FLOAT);
 SetShaderValue(mosaic, mos_aLoc, &flags.aspect_ratio, SHADER_UNIFORM_FLOAT);


 // Scroll shader crap
 //
 scroll   = LoadShader(0, TextFormat("shaders/scroll_xy_%i.fs", GLSL_VERSION));
 off_xLoc = GetShaderLocation(scroll, "offset_x");
 off_yLoc = GetShaderLocation(scroll, "offset_y");


 // CRT Shader crap
 //
 crt      = LoadShader(0, TextFormat("shaders/crt_%i.fs", GLSL_VERSION));

 SetShaderValue(crt, GetShaderLocation(crt, "size"), &flags.screenSize, SHADER_UNIFORM_VEC2);

 return;
}




void load_audio()
{

 #ifdef USE_FM_SYNTH
     FM_load_assets();
 #endif

 sfx[80]  = LoadSound("sfx/080.wav");     // YO! Block shot
 sfx[81]  = LoadSound("sfx/081.wav");     // ACCEPT - GUI beep

 // Set sound effect attributes (pitch, volume)
 //
 set_sound(10,  1.00, 0.15);
 set_sound(14,  1.00, 0.30);
 set_sound(15,  1.00, 0.30);
 set_sound(17,  1.00, 0.30);
 set_sound(80,  1.00, 0.30);
 set_sound(81,  1.00, 0.30);
 set_sound(82,  1.00, 0.30);
 set_sound(83,  1.00, 0.30);
 set_sound(200, 1.00, 0.30);
 set_sound(201, 1.00, 0.30);


 // Load music
 //
 //muzak[0] = LoadMusicStream("sfx/race.mp3");
 //muzak[1] = LoadMusicStream("sfx/tour.mp3");
 //SetMusicVolume(muzak[0], 0.20);
 //SetMusicVolume(muzak[1], 0.20);

 return;
}





int main(void)
{

 // Init OpenGL instance. If MIDI tweaking is in use, add 300 pixels
 // at bottom of window for rendering knobs and pads
 //
 SetConfigFlags(FLAG_VSYNC_HINT);


 #ifdef USE_RTMIDI
     InitWindow(SCREEN_W * OS_SCALING, (SCREEN_H + 300) * OS_SCALING, WINDOW_TITLE);
     screenbuf   = LoadRenderTexture(SCREEN_W, (SCREEN_H + 300));
     post_target = LoadRenderTexture(SCREEN_W, (SCREEN_H + 300));
 #else
     InitWindow(SCREEN_W * OS_SCALING, SCREEN_H * OS_SCALING, WINDOW_TITLE);
     screenbuf   = LoadRenderTexture(SCREEN_W, SCREEN_H);
     post_target = LoadRenderTexture(SCREEN_W, SCREEN_H);
 #endif

 flags.aspect_ratio  = (float)((float)SCREEN_W / (float)SCREEN_H);
 flags.screenSize[0] = (float)GetScreenWidth();
 flags.screenSize[1] = (float)GetScreenHeight();


 InitAudioDevice();

 // Only use this is vsync isn't available
 //
 // SetTargetFPS(60);


 // CONFIG SETTING: Hides mouse cursor
 //
 #ifdef HIDE_MOUSE_CURSOR
     HideCursor();
 #endif

 // CONFIG SETTING: ESC does not exit to OS
 //
 #ifdef NO_ESCAPE_TO_OS
     SetExitKey(0);
 #endif


 /// FEATURE SETS ///

 #ifdef USE_LOG
     open_log();
 #endif

 #ifdef USE_RTMIDI
     init_midi();
     init_arturia_profile();
     load_knobs();

     tex_knob         = LoadTexture("gfx/tex_knob.png");
     tex_knob_plate   = LoadTexture("gfx/tex_knob_plate.png");

     rescale_midi_device_rel(midi.knobs[1],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[2],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[3],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[4],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[5],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[6],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[7],  0.0,   1.0, 0.01); //
     rescale_midi_device_rel(midi.knobs[8],  0.0,   1.0, 0.01); //
 #endif


 load_textures();
 load_fonts();
 load_shaders();
 load_audio();


 generate_animations();


 // Initialize vars that only set once
 //
 flags.tutorial_seen    = 0;


 // Gamepad placeholder
 //
 log("Gamepad name = %s\n",GetGamepadName(0));
 log("Axis count   = %d\n", GetGamepadAxisCount(0));


 // We will call this routine to clean up on program exit
 //
 atexit(cleanup);

 core_game_loop();

 return(0);
}





// This routine is automatically called at program exit.
// I should unload all resources, but I'm a motherfucker and don't care.
// Let the OS do my job for me, since it wants to control everything.
//
void cleanup()
{

 #ifdef USE_LOG
     close_log();
 #endif

 #ifdef USE_RTMIDI
     save_knobs();
 #endif


 CloseWindow();                // Close window and OpenGL context

 return;
}






// Performs logic update and calls rendering stuff
//
void update_and_render()
{
 flags.total_actors = 0;


 if(WindowShouldClose()) { exit(0); }


 #ifdef USE_RTMIDI
 poll_midi();
 #endif


 // Vsync toggle (should show message or something)
 //
 if(IsKeyPressed(KEY_F10) && !hotkey_toggles[300]) {
     hotkey_toggles[300] = 1;
     if(IsWindowState(FLAG_VSYNC_HINT)) { ClearWindowState(FLAG_VSYNC_HINT); }
     else                               { SetWindowState(FLAG_VSYNC_HINT);   }
                                                   }
 else {
     hotkey_toggles[300] = 0;
      }


 // CRT shader toggle
 //
 if(IsKeyPressed(KEY_F2) && !hotkey_toggles[302]) {
     hotkey_toggles[302] = 1;
     flags.use_crt ^= 1;
                                                  }
 else { hotkey_toggles[302] = 0; }



 // Fullscreen toggle
 //
 if(IsKeyPressed(KEY_F3) && !hotkey_toggles[303]) {
     hotkey_toggles[303] = 1;
     ToggleFullscreen();
                                                  }
 else { hotkey_toggles[303] = 0; }


 #ifdef ENABLE_DEBUG_KEYS

 // Debugging information toggle
 //
 if(IsKeyPressed(KEY_F1) && !hotkey_toggles[301]) {
     hotkey_toggles[301] = 1;
     flags.debug ^= 1;
                                                  }
 else {
     hotkey_toggles[301] = 0;
      }


 /// SPAWN ENEMY
 ///
 if(IsKeyPressed(KEY_F5) && !hotkey_toggles[305]) {
     hotkey_toggles[305] = 1;
     spawn_wave();
                                                  }
 else {
     hotkey_toggles[305] = 0;
      }


 /// SPAWN BROWN BOMBER
 ///
 if(IsKeyPressed(KEY_F6) && !hotkey_toggles[306]) {
     hotkey_toggles[306] = 1;
     spawn_brown_bomber_block();
                                                  }
 else {
     hotkey_toggles[306] = 0;
      }


 /// CLEAR FIELD
 ///
 if(IsKeyPressed(KEY_F7) && !hotkey_toggles[307]) {
     hotkey_toggles[307] = 1;
     TEST_fill_container(0);
     TEST_fill_container(1);
     TEST_fill_container(2);
                                                  }
 else {
     hotkey_toggles[307] = 0;
      }

 #endif

 // Track delta time and call update routines as needed
 //
 check_delta_updates();

 check_time();

 render_frame(flags.game_mode);

 //if(IsMusicStreamPlaying(muzak[0])) { UpdateMusicStream(muzak[0]); }
 //if(IsMusicStreamPlaying(muzak[1])) { UpdateMusicStream(muzak[1]); }

 return;
}






// NOTE: Reduces boilerplate in above routine
//
void check_tutorial_dist(float check_x, float check_y, float box_x, float box_y, float box_w, float box_h, int msg)
{

 if(check_rect_collision(actors[puppet].pos.x, actors[puppet].pos.y,
    check_x - 100, check_y - 100, 200, 200, 1, 1)) {
     textbox[msg].hold = 1;
     if(!textbox[msg].enabled) { trigger_textbox(msg, box_x, box_y, box_w, box_h, msg, 0, 10); }
                                                   }
 else { textbox[msg].hold = 0; }

 return;
}





/// SCREEN_W / 2, 200 , 900, 240


#ifdef USE_TIPS
void check_tips()
{
 int i  = 0;
 int _t = 0;


 if(flags.tutorial) {
     _t = 0;
     if(flags.game_time < 600) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                              }
     else { textbox[_t].hold = 0; }


     _t = 1;
     if(flags.game_time > 800 && flags.game_time < 1400) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                         }
     else { textbox[_t].hold = 0; }


     _t = 2;
     if(flags.game_time > 1600 && flags.game_time < 2200) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 3;
     if(flags.game_time > 2400 && flags.game_time < 3000) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 4;
     if(flags.game_time > 3200 && flags.game_time < 3800) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 5;
     if(flags.game_time > 4000 && flags.game_time < 4600) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) {
             trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10);
             spawn_yo_block();
                                  }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 6;
     if(flags.game_time > 4800 && flags.game_time < 5400) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) {
             trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10);
             spawn_brown_bomber_block();
                                  }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 7;
     if(flags.game_time > 5600 && flags.game_time < 6200) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                          }
     else { textbox[_t].hold = 0; }


     _t = 8;
     if(flags.game_time > 6400 && flags.game_time < 7000) {
         textbox[_t].hold = 1;
         if(!textbox[_t].enabled) { trigger_textbox(_t, tips[_t].window.x, tips[_t].window.y, tips[_t].window.width, tips[_t].window.height, tips[_t].msg_index, 0, 10); }
                                                          }
     else { textbox[_t].hold = 0; }
                    }

 return;
}
#endif









void draw_actor(int slot)
{
 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return; }

 if(!actors[slot].enabled) { return; }
 if(!actors[slot].visible) { return; }

 float x_flip    = 1.0;
 float alpha     = 1.0;

 Vector2 origin  = { (actors[slot]._size_w / 2) * actors[slot].scale, (actors[slot]._size_h / 2) * actors[slot].scale };

 flags.total_actors++;

 // Flip sprite horizontally if path of travel is negative on x axis
 //
 if(actors[slot].flip) { x_flip = -1.0; /*s_flip = - 4;*/ }

 Rectangle source  = { (actors[slot]._size_w * actors[slot].cel_x), (actors[slot]._size_h * actors[slot].cel_y), actors[slot]._size_w * x_flip, actors[slot]._size_h };


 /// Setting the origin influences these values
 /// Note that we don't need to center the destination on the X axis
 ///                       vv vv vv vv
 Rectangle dest     = { actors[slot].pos.x, actors[slot].pos.y - ((actors[slot]._size_h * actors[slot].scale) / 2) - actors[slot].pos.z + (actors[slot].y_shift * actors[slot].scale), (actors[slot]._size_w * actors[slot].scale), (actors[slot]._size_h * actors[slot].scale) };

 //dest.y -= actors[slot].pos.z;


 // Y jitter sends destination coords +/- 1 PIX at random
 //
 if(actors[slot].jitter_y) {
     if(quick_rand(2) & 1) { dest.y += PIX; }
     else                  { dest.y -= PIX; }
                           }


 // Handle flickering effect (refer to [ALPHA] instead of actors[].blend, from here out)
 //
 if(actors[slot].flicker) {
     alpha = 0.25 + (float)quick_rand(500) / 1000.0;
     alpha *= actors[slot].blend;
                          }
 else { alpha = actors[slot].blend; }


 if(actors[slot].mirror) { source.width *= -1; }


 /// OPTIMIZATION TARGET FOR NEXT RELEASE
 ///
 switch(actors[slot].effect) {
     case 1: // Normal blit + wave shader (FIRE SINE)
             SetShaderValue(wave,  freqXLoc, &f_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &f_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &f_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &f_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &f_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &f_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 2: // Custom code for brush (BRUSH SINE);
             SetShaderValue(wave,  freqXLoc, &s_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &s_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &s_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &s_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &s_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &s_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTextureEx(actors[slot].cel, (Vector2){actors[slot].pos.x,   (actors[slot].pos.y - (32.0 * actors[slot].scale))}, 0.0, actors[slot].scale, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 3: // Additive blur
             BeginBlendMode(BLEND_ADDITIVE);
             blend_helper(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha * 0.10));
             EndBlendMode();
             break;

     case 4: // Kelp blit + wave shader (KELP SINE)
             SetShaderValue(wave,  freqXLoc, &k_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &k_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &k_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &k_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &k_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &k_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
               DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 7: // Squid death blit + wave shader (LINE SINE)
             SetShaderValue(wave,  freqXLoc, &l_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &l_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &l_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &l_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &l_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &l_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
               DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

    case 10: {
             // Display variable over top of actor
             char blergh[80];
             Color col = BLANK;

             sprintf(blergh, "%02d", actors[slot].mode);
             if(actors[slot].mode < 5)   { col = SHOCK_RED;   }
             if(actors[slot].mode >= 5)  { col = YELLOW;      }
             if(actors[slot].mode >= 10) { col = SCORE_GREEN; }

             justify_text_xy(blergh, dest.x, dest.y - 65, font4, BLACK, 4, 1);
             justify_text_xy(blergh, dest.x-2, dest.y - 67, font4, col, 4, 1);

             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             break;
             }

    case 20: // Draw a pixel where this actor would normally go
             DrawRectangle((int)actors[slot].pos.x - 3, (int)actors[slot].pos.y - 3, 6, 6, actors[slot].color);
             break;

    case 21: // Draw a pixel where this actor would normally go
             {
             Color sprite_color = BLANK;
             sprite_color = ColorFromHSV(anims[4], 1.0, 1.0);

             BeginBlendMode(BLEND_ADDITIVE);
             DrawRectangle((int)actors[slot].pos.x,     (int)actors[slot].pos.y - 3, 6, 6, sprite_color);
             DrawRectangle((int)actors[slot].pos.x - 3, (int)actors[slot].pos.y - 3, 6, 6, sprite_color);
             DrawRectangle((int)actors[slot].pos.x + 3, (int)actors[slot].pos.y - 3, 6, 6, sprite_color);
             EndBlendMode();
             break;
             }

    case 30: // Draw flickering aura behind sprite
             {
             Vector2 decal = { dest.x, dest.y };

             alpha = 0.25 + (float)quick_rand(500) / 1000.0;
             alpha *= actors[slot].blend;
             tex_blit(tex_aura, 0, 0, decal.x, decal.y, 64, 64, anims[13], 3.0, Fade(WHITE, alpha));

             alpha = actors[slot].blend;
             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             break;
             }

    case 99: // Do nothing (if visibility is being fucked with)
             break;

    default: {
             // Normal blit
             /// Uncomment if shadows are supported in this project
             if(actors[slot].shadow) {
                 DrawTexturePro(actors[slot].cel, (Rectangle){224, 0, 16, 20}, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
                                     }

             /// Debugging lines ///
             if(flags.debug) {
                 DrawLine(0, actors[slot].pos.y, 2000, actors[slot].pos.y, Fade(WHITE, 0.25));
                 DrawLine(actors[slot].pos.x, 0, actors[slot].pos.x, 2000, Fade(WHITE, 0.25));
                             }

             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));

             if(flags.debug) {
                 char blergh[80];
                 sprintf(blergh, "S %02d", actors[slot].state);
                 DrawText(blergh, dest.x, dest.y - 65, 10.00, WHITE);
                 sprintf(blergh, "X %.1f", actors[slot].pos.x);
                 DrawText(blergh, dest.x, dest.y - 55, 10.00, WHITE);
                 sprintf(blergh, "Y %.1f", actors[slot].pos.y);
                 DrawText(blergh, dest.x, dest.y - 45, 10.00, WHITE);
                 sprintf(blergh, "Z %.1f", actors[slot].pos.z);
                 DrawText(blergh, dest.x, dest.y - 35, 10.00, WHITE);
                             }
             break;
             }
                             }



 return;
}





// NOTE: This is only called by the above routine, when additive blending, to keep the code from being jank
//
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint)
{
 float drift = 3;

 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);


 // Next pass
 //
 drift = 2;

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 return;
}










#ifdef USE_BULLETIN
void draw_bulletin()
{
 Vector2 pos = { 0 };
 Vector2 len = { 0 };

 Color col   = BLANK;

 if(!bulletin.enabled) { return; } // Nothing to do

 // Draw bottom status bar
 //
 if(bulletin.position) {
     pos.x = 0;
     pos.y = SCREEN_H - bulletin.height;
     DrawRectangleGradientV(pos.x, pos.y, SCREEN_W, bulletin.height, Fade(bulletin.banner_col, 0.25), Fade(bulletin.banner_col, 0.75));
                       }
 else {
     pos.x = 0;
     pos.y = 0;
     DrawRectangleGradientV(pos.x, pos.y, SCREEN_W, bulletin.height, Fade(bulletin.banner_col, 0.75), Fade(bulletin.banner_col, 0.25));
      }


 if(bulletin.time_left == 0) { return; } // Nothing to do


 // If we are about to expire, fade text out
 //
 if(bulletin.time_left < 255 && bulletin.time_left > -1) {
     col = Fade((Color)bulletin.msg_col, (float)(bulletin.time_left / 255.0));
                                                         }
 else { col = (Color)bulletin.msg_col; }


 len = MeasureTextEx(bulletin.font, bulletins[bulletin.message], bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing);

 if(bulletin.time_left != 0) {
     pos.x = 0 - bulletin.x;
     pos.y += (bulletin.height - len.y) / 2.0; // Center text on Y in bulletin banner
     DrawTextEx(font1, bulletins[bulletin.message], pos, bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing, col);

     pos.x += MeasureTextEx(font1, bulletins[bulletin.message], bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing).x;
     DrawTextEx(font1, bulletins[bulletin.message], pos, bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing, col);

     pos.x += MeasureTextEx(font1, bulletins[bulletin.message], bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing).x;
     DrawTextEx(font1, bulletins[bulletin.message], pos, bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing, col);
                            }

 return;
}

#endif // USE_BULLETIN









void draw_signal()
{
 Vector2 len_a   = { 0 };
 Vector2 len_b   = { 0 };
 float total_len = 0.0;
 float alpha     = 1.0;

 // Set alpha based off position in range (fade in/out)
 //
 if(flags.signal_time <= flags.signal_f_in) {
     alpha = rescale(flags.signal_time, 0.0, flags.signal_f_in, 0.0, 1.0);
                                            }

 if(flags.signal_time >= flags.signal_f_out) {
     alpha = rescale(flags.signal_time, flags.signal_f_out, flags.signal_max_time, 1.0, 0.0);
                                             }


 len_a = MeasureTextEx(font1, "CONTAINER LAUNCH", (font1.baseSize * 6), 6.0);
 total_len = len_a.x;

 DrawTextEx(font1, "CONTAINER LAUNCH", (Vector2){(SCREEN_W / 2) - (total_len / 2) + 6, (SCREEN_H  * 0.10) + 6}, font1.baseSize * 6.0, 6.0, Fade(GRAY, alpha));
 DrawTextEx(font1, "CONTAINER LAUNCH", (Vector2){(SCREEN_W / 2) - (total_len / 2), (SCREEN_H  * 0.10)}, font1.baseSize * 6.0, 6.0, Fade(SCORE_ORANGE, alpha));

 len_b = MeasureTextEx(font1, "10000 POINTS", (font1.baseSize * 4), 4.0);
 DrawTextEx(font1, "10000 POINTS", (Vector2){(SCREEN_W / 2) - (len_b.x / 2) + 4, (SCREEN_H  * 0.22) + 4}, font1.baseSize * 4.0, 4.0, Fade(GRAY, alpha));
 DrawTextEx(font1, "10000 POINTS", (Vector2){(SCREEN_W / 2) - (len_b.x / 2), (SCREEN_H  * 0.22)}, font1.baseSize * 4.0, 4.0, Fade(YELLOW, alpha));

 return;
}





// Copied-over framework stuff goes here



void merge_actors()
{
 int i = 0;

 // Decals first
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }


 // Everything else
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(!actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }

 return;
}







// Add hook to allow for different manners of sorting outside the framework
//
// NOTE: For use with quicksort implementation
//
void prep_for_sort()
{
 int i    = 0;

     for(i=0; i<MAX_ACTORS; i++) {
         sorted[i][0] = -1;
         sorted[i][1] = -1;

         if(actors[i].enabled && !actors[i].accessory) {
             sorted[i][0] = actors[i].pos.y;
             sorted[i][1] = i;
                                                       }
                                 }

 return;
}







void init_game_variables()
{
 int i        = 0;
 int j        = 0;

 puppet       = -1;
 flags.game_mode = 0;


 for(i=0; i<16; i++) { sfx_buffer[i][0] = -1; sfx_buffer[i][1] = 0; }
 for(i=0; i<16; i++) { anims[i] = 1.0; }


 #ifdef USE_HIGH_SCORE
     high_init[0] = 0;
     high_init[1] = 0;
     high_init[2] = 0;
     high_init[3] = 0;

     hi_score.selected    = 0;
     hi_score.initials[0] = 0;
     hi_score.initials[1] = 0;
     hi_score.initials[2] = 0;
     hi_score.blink       = 0;
     hi_score.blink_timer = 0;
 #endif

 #ifdef USE_TEXTBOX
     box_tex_x  = 0;
     box_tex_y  = 0;
     box_update = 0;

     for(i=0; i<MAX_TEXTBOX; i++) {
         textbox[i].pos.x = 0.0;
         textbox[i].pos.y = 0.0;
         textbox[i].pos.width  = 0;
         textbox[i].pos.height = 0;
         textbox[i].scale = 0.0;
         textbox[i].mode = 0;
         textbox[i].ticks = 0;
         textbox[i].viewable_text = 0;
         textbox[i].msg = NULL;
         textbox[i].enabled = 0;
                                  }
 #endif


 #ifdef USE_RINGS
     for(i=0; i<MAX_RINGS; i++) { init_ring(i); }
 #endif


 #ifdef USE_BULLETIN
     bulletin.enabled    = 0;
     bulletin.position   = 0;
     bulletin.time_left  = 0;
     bulletin.speed      = 3;
     bulletin.height     = 60;
     bulletin.x          = 0;
     bulletin.message    = 0;
     bulletin.msg_col    = WHITE;
     bulletin.banner_col = BLACK;
     bulletin.font       = font1;
     bulletin.f_scale    = 3.0;
     bulletin.f_spacing  = 3.0;
 #endif


 // Define camera (this will center camera, with focus in middle of screen for rotation)
 // Suitable for use with zooming
 //
 camera.target   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.offset   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;



 // Set up actors
 //
 for(i=0; i<MAX_ACTORS; i++) { kill_actor(i); }

 spawn_permanent_actors();


 flags.delta            = 0.0;
 flags.delta_factor     = 1.0;
 flags.timing_leftover  = 0.0;
 flags.last_updates     = 0;

 flags.game_time        = 0.0;
 flags.clock_min        = 0;
 flags.clock_sec        = 0;
 flags.clock_sub        = 0;

 flags.debug            = 0;
 flags.tutorial         = 0;
 flags.basic_tutorial   = 0;
 flags.game_over        = 0;
 flags.game_ending      = 0;
 flags.stage_complete   = 0;
 flags.paused           = 0;
 flags.use_crt          = 1;

 flags.menu_pos         = 0;
 flags.game_stage       = 0;
 flags.selected         = -1;
 /// flags.aspect_ratio;          // Initialized elsewhere

 flags.tint_col         = BLACK;
 flags.tint_str         = 0.0;
 flags.tint_velocity    = 0.0;

 flags.game_speed       = 1.0;
 flags.game_velocity    = 0.0;

 flags.mosaic           = 0.00;
 flags.mosaic_velocity  = 0.00;

 flags.quake_duration = 0;

 flags.show_signal      = -1;
 flags.signal_time      = 0;
 flags.signal_max_time  = 0;
 flags.signal_data[0]   = 0;
 flags.signal_data[1]   = 0;
 flags.signal_f_in      = 0.0;
 flags.signal_f_out     = 0.0;

 flags.high_score       = 666;
 flags.score            = 0;
 flags.score_shake      = 0;
 flags.score_diff       = 0;

 for(i=0; i<64; i++) {
     flags.embers[i][0] = 0;
     flags.embers[i][1] = 0;
     flags.embers[i][2] = 0;
                     }

 /// Wipe anything below this, between entries
 ///
 flags.covered           = 0;
 flags.covered_sub       = 0;
 flags.covered_countdown = 10;

 flags.sum_launches     = 0;
 flags.sum_hits         = 0;
 flags.sum_escapes      = 0;
 flags.sum_yos          = 0;

 flags.shot_ready       = 0;
 flags.rapid_fire       = 0;
 flags.flip             = 0;
 flags.flip_dir         = 0;

 flags.next_yo          = 5000;
 flags.yo_factor        = 1.0;

 for(i=0; i<FIELD_Y; i++) {
     for(j=0; j<FIELD_X; j++) {
         pixel_field[i][j] = 0;
         barrier_field[i][j] = 0;
                              }
                          }

 mark_field_containers();

 for(j=0; j<MAX_TIPS; j++) {
     tips[j].active    = 1;
     tips[j].msg_index = 1 + j;
     tips[j].window.x  = SCREEN_W / 2;
     tips[j].window.y  = SCREEN_H / 6;
     tips[j].window.width = SCREEN_W * 0.9;
     tips[j].window.height = SCREEN_H * 0.20;
                           }

 return;
}





void render_frame(int mode)
{
 int i             = 0;
 float quake_scale = 0.0;

 Rectangle src     = { 0 };
 Rectangle dst     = { 0 };


 if(flags.quake_duration) {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;

     quake_scale = 15.0 * ((float)flags.quake_duration / 180.00);
     camera.offset.x += GetRandomValue(-quake_scale, quake_scale);
     camera.offset.y += GetRandomValue(-quake_scale, quake_scale);
     flags.quake_duration--;
                    }
 else {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;
      }



 BeginDrawing();
 BeginTextureMode(screenbuf);
 ClearBackground(BLACK);

 BeginMode2D(camera);

 // Loop through tilemap and draw things
 // We will let the GPU kick out anything that doesn't fit in the frame
 // Because we are lazy
 //
 if(flags.game_mode > 0) {

     /// Draw scenery
     draw_sky();
     draw_pixel_field();
     draw_containers();

     // Sort and insert actors
     //
     prep_for_sort();
     quicksort(0,(MAX_ACTORS-1));
     merge_actors();
                         }


 #ifdef USE_RINGS
     draw_rings();
 #endif


 EndMode2D();

 // Having drawn all the necessary stuff, handle mode-specific overlays
 // that assume the camera has been disabled (so coords are at 0,0)
 //
 switch(flags.game_mode) {
     case 0: // Title screen
             draw_title();
             draw_title_menu("...");
             break;

     case 1: // Introduction / Static Tutorial
             break;

     case 2: // In-game
             if(flags.show_signal != 0) { draw_signal(); }
             break;

     case 3: // Game over / Summary (LOSE)
             draw_summary(0);
             break;

     case 4: // Game over / Summary (WIN)
             draw_high_score();
             break;
                         }


 #ifdef USE_TEXTBOX
     for(i=0; i<MAX_TEXTBOX; i++) {
         if(textbox[i].enabled) { draw_text_box(i); }
                                  }
 #endif


 #ifdef USE_BULLETIN
     draw_bulletin();
 #endif


 // Full screen tint
 //
 if(flags.tint_str != 0.0) {
     DrawRectangle(0, 0, SCREEN_W, SCREEN_H, Fade(flags.tint_col, flags.tint_str));
                           }


 if(!flags.game_over && flags.game_mode == 2) { draw_hud(); }

 #ifdef USE_RTMIDI
    draw_midi_knobs();
 #endif

 if(flags.game_mode < 2) { draw_control_hints(0); }
 else                    { draw_control_hints(1); }

 if(flags.debug) { EndMode2D(); DrawFPS(10, 30); }

/*
     char blergh[80];

     sprintf(blergh, "C.X %f", flags.cam_height);
     DrawText(blergh, 5, 100, 40, WHITE);

     sprintf(blergh, "P.Y %f", actors[puppet].pos.y);
     DrawText(blergh, 5, 150, 40, WHITE);

     sprintf(blergh, "C.F %f", flags.cam_height + actors[puppet].pos.y);
     DrawText(blergh, 5, 200, 40, WHITE);

     sprintf(blergh, "SEG %d",  get_segment(actors[puppet].pos.z) % stages[0].length);
     DrawText(blergh, 5, 250, 40, WHITE);
*/



 EndTextureMode();

 /// Post-processing
 render_post_frame();



 // Scale FBO to screen (NOTE: Australian height)
 //
 push_rect(&src, 0, 0, (float)screenbuf.texture.width, -(float)screenbuf.texture.height);

 #ifdef USE_RTMIDI
 push_rect(&dst, 0, 0, SCREEN_W * OS_SCALING, (SCREEN_H + 300) * OS_SCALING);
 #else
 push_rect(&dst, 0, 0, SCREEN_W * OS_SCALING, SCREEN_H * OS_SCALING);
 #endif

 if(flags.use_crt) { BeginShaderMode(crt); }
     DrawTexturePro(screenbuf.texture, src, dst, (Vector2){ 0, 0 }, 0.0, WHITE);
 if(flags.use_crt) { EndShaderMode(); }

 EndDrawing();

 return;
}





void render_post_frame()
{

 // Post-processing is accomplished via incredibly lazy series of blits between FBOs
 // while turning on the appropriate shader. End result is still populated in "screenbuf"
 //
 if(flags.mosaic > 0.0) { // Mosaic effect
     BeginTextureMode(post_target);
         BeginShaderMode(mosaic);
             DrawTexture(screenbuf.texture, 0, 0, WHITE);
         EndShaderMode();
     EndTextureMode();

     BeginTextureMode(screenbuf);
         DrawTexture(post_target.texture, 0, 0, WHITE);
     EndTextureMode();
                        }

 return;
}


